nx_server_plugin_sdk 1.0 Server Plugin SDK

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
nx::sdk::IUtilityProvider4 Class Referenceabstract
Inheritance diagram for nx::sdk::IUtilityProvider4:

## Classes
class | IHttpRequestCompletionHandler

## Public Types
enum | HttpDomainName : int { cloud, vms }
using | IHttpRequestCompletionHandler0 = IHttpRequestCompletionHandler

## Public Member Functions
void | sendHttpRequest (HttpDomainName requestDomainName, const char *url, const char *httpMethod, const char *mimeType, const char *requestBody, Ptr< IHttpRequestCompletionHandler > callback) const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider4, IUtilityProvider3 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider3
virtual IString * | cloudSystemId () const =0
virtual IString * | cloudAuthKey () const =0
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider3, IUtilityProvider2 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider2
virtual const char * | serverId () const =0
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider2, IUtilityProvider1 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider1
std::string | serverSdkVersion () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider1, IUtilityProvider0 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider0
virtual int64_t | vmsSystemTimeSinceEpochMs () const =0
std::string | homeDir () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider0 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IRefCountable
virtual | ~IRefCountable ()=default
template<class Interface >
Ptr< Interface > | queryInterface ()
template<class Interface >
Ptr< const Interface > | queryInterface () const
virtual int | addRef () const =0
virtual int | releaseRef () const =0
int | refCountThreadUnsafe () const

## Static Public Member Functions
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider3
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider2
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider1
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider0
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IRefCountable
static auto | interfaceId ()

## Protected Member Functions
virtual void | doSendHttpRequest (HttpDomainName requestDomainName, const char *url, const char *httpMethod, const char *mimeType, const char *requestBody, IHttpRequestCompletionHandler *callback) const =0
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider4, IUtilityProvider3 >
virtual IRefCountable * | queryInterface (const IRefCountable::InterfaceId *id) override
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider3, IUtilityProvider2 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider2, IUtilityProvider1 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::IUtilityProvider1
virtual const IString * | getServerSdkVersion () const =0
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider1, IUtilityProvider0 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::IUtilityProvider0
virtual const IString * | getHomeDir () const =0
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider0 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)

## Additional Inherited Members
Static Protected Member Functions inherited from nx::sdk::IRefCountable
template<int len>
static const InterfaceId * | makeId (const char(&charArray)[len])
template<int len, int alternativeLen>
static std::vector< const InterfaceId * > | makeIdWithAlternative (const char(&charArray)[len], const char(&alternativeCharArray)[alternativeLen])
template<class TemplateInstance , class TemplateArg , int len>
static const InterfaceId * | makeIdForTemplate (const char(&baseIdCharArray)[len])
static std::vector< const InterfaceId * > | alternativeInterfaceIds (const InterfaceId *id)
static std::vector< const InterfaceId * > | alternativeInterfaceIds (std::vector< const InterfaceId *> ids)

## Member Function Documentation

## ◆ doSendHttpRequest()

virtual void nx::sdk::IUtilityProvider4::doSendHttpRequest | ( | HttpDomainName | requestDomainName,
|  | const char * | url,
|  | const char * | httpMethod,
|  | const char * | mimeType,
|  | const char * | requestBody,
|  | IHttpRequestCompletionHandler * | callback
| ) |  | const
| protected pure virtual

Called by sendHttpRequest()

Implemented in nx::vms_server_plugins::analytics::test::UtilityProvider.

## ◆ sendHttpRequest()

void nx::sdk::IUtilityProvider4::sendHttpRequest | ( | HttpDomainName | requestDomainName,
|  | const char * | url,
|  | const char * | httpMethod,
|  | const char * | mimeType,
|  | const char * | requestBody,
|  | Ptr< IHttpRequestCompletionHandler > | callback
| ) |  | const
| inline

Allows to send asynchronous HTTP requests to the Cloud or VMS Server. IHttpRequestCompletionHandler::execute() will be called later. An error or HTTP response will be passed to this method as a parameter. HTTP response will consist of a status line, HTTP headers and a message body separated by an empty line.

The documentation for this class was generated from the following file:

- src/nx/sdk/i_utility_provider.h